<?php
/*
** File:           dbfunctions.php
** Author:         nuSoftware
** Created:        2007/04/26
** Last modified:  2009/12/31
**
** Copyright 2004, 2005, 2006, 2007, 2008, 2009 nuSoftware
**
** This file is part of the nuBuilder source package and is licensed under the
** GPLv3. For support on developing in nuBuilder, please visit the nuBuilder
** wiki and forums. For details on contributing a patch for nuBuilder, please
** visit the `Project Contributions' forum.
**
**   Website:  http://www.nubuilder.com
**   Wiki:     http://wiki.nubuilder.com
**   Forums:   http://forums.nubuilder.com
*/

require_once("config.php");

function dbQuery($DBHost, $DBName, $DBUserID, $DBPassWord, $pSQL, $pStopOnError){
//---------open connection and database and return query
	static $con;
	global $NUExtraHTTPHeaders;
	if(!isset($con)){
		$con             = mysql_connect($DBHost,$DBUserID,$DBPassWord)  or die ("Could not connect to database");
		if($NUExtraHTTPHeaders && !headers_sent()){
			header("X-MySQL-Thread: ".mysql_thread_id());	
		}
		mysql_query("SET NAMES 'utf8'");
		//mysql_query("SET CHARACTER_SET utf8");
		mysql_select_db($DBName,$con) or die ("Could not select database");
	}
	$t           = mysql_query($pSQL);
	if (!$t && $pStopOnError) {
		
		handleQueryError($pSQL,mysql_errno($con),mysql_error($con));
	
	} else {
//---------log SQL statements
		if(strtoupper(substr(trim($pSQL), 0, 7))!='SELECT'){
			$t1       = mysql_query("Select * From zzsys_setup");
			$setup   = mysql_fetch_object($t1);
			if($setup->set_log_sql == '1'){
				$hex = str_hex($pSQL);
				mysql_query("INSERT INTO zzsys_sql_log (sql_sql) VALUES ('$hex')");
			}
		}
	}
	return $t;
}

function handleQueryError($pSQL,$pErrorNumber,$pError) {

	if ($GLOBALS['hasFailed']) { //Prevent recursion if logging the error fails, i.e. if this function has already been called once, bail.
		
		//Skip function, go straight to die()
		
	} else {
	
		$GLOBALS['hasFailed'] = true; //Prevent recursion
		
		require_once("common.php");
		
		// Make it match the styling of the site
		echo "<html class='unselected'><head>".makeCSS()."<style>
		.actionButton,#loggedin,#pagetitle {display:  none;}
		</style></head><body style='width: 100%; height: 100%; margin: 0px;'>
		<div style='position: absolute; top: 10px; left: 10px; width: 972px; height: 600px; text-align: left; border-width: 4px;'>
		<div id='browse' class='browse' style='overflow: auto; visibility: visible; width: 920px; height: 556px; padding: 2em;'>
		<div class='BorderDiv' style='margin:-2em -2em 1em -2em;'><h1 class='unselected' style='font-weight: bold; padding: 0.5em; margin: 0px;' id='top'>Error</h1></div>
		";
		
		$db = $GLOBALS['dir'];

		$errorReference = substr(uniqid(),-7); //Effectively a random hexadecimal string, short enough to quote over the phone
		
		// Get custom email addresses and error message details (for this site)
		@ include("../$db/config.php"); //Includes $ErrorUserMessage, $ErrorFromEmailAddress and $ErrorEmailAdminAddressList, ErrorEmailClientAddressList, $ErrorReplyEmailAddress. Won't fail if this file is missing.
		
		if (!$ErrorOverrideGlobalAddresses || !isset($ErrorUserMessage) || !isset($ErrorFromEmailAddress) || !isset($ErrorEmailAdminAddressList) || !isset($ErrorReplyEmailAddress)) {
			
			//$ErrorEmailClientAddressList is not retrieved from the global config.php - it can only be set on a per-site basis
			
			// Default action is to concatenate global and site admin email addresses. Of set to override, site address list will be used (but fall back if it doesn't exist)
			if (!$ErrorOverrideGlobalAddresses) {
			    $ErrorEmailAdminAddressList = $GLOBALS['NUErrorEmailAdminAddressList'].",".$ErrorEmailAdminAddressList;
			}
			if(!isset($ErrorUserMessage)) 			{$ErrorUserMessage = $GLOBALS['NUErrorUserMessage'];}
			if(!isset($ErrorFromEmailAddress)) 		{$ErrorFromEmailAddress = $GLOBALS['NUErrorFromEmailAddress'];}
			if(!isset($ErrorEmailAdminAddressList))	{$ErrorEmailAdminAddressList = $GLOBALS['NUErrorEmailAdminAddressList'];}
			if(!isset($ErrorReplyEmailAddress))		{$ErrorReplyEmailAddress = $GLOBALS['NUErrorReplyEmailAddress'];}		
		}
		
		$errorMessage = ($ErrorUserMessage) ? $ErrorUserMessage : "An error has occurred while running this query. Please contact technical support and quote error reference: ";
		echo "<div style='width: 95%; border: 1px solid red; padding: 1em;'>$errorMessage <a href='mailto:$ErrorReplyEmailAddress?subject=Error Reference: $errorReference, Site: $db&body=An internal error occurred while I was [ENTER WHAT YOU WERE DOING]. %0AThis problem started [ENTER WHEN YOU FIRST SAW THIS ERROR]. %0AThe error reference is $errorReference.'>$errorReference</a>.</div>";

		//Log error to database (if it fails, the global hasFailed will prevent an infinite loop of failure)
		$logMessage = "Error Reference: $errorReference\nAn error occurred while running the following query:\n$pSQL";
		
		tofile($logMessage);
	
		if ($_SERVER['SERVER_PORT'] == 443) {
			$protocol = 'https://';
		} else {
			$protocol = 'http://';
		}
	
		$verboseOutput = "
			<h2>SQL</h2>
			<p>".htmlspecialchars($pSQL)."</p>
			<h2>Error</h2>
			<p>".htmlspecialchars("{$pErrorNumber}: {$pError}")."</p>
			<h2>URL</h2>
			<p>".htmlspecialchars($protocol.$GLOBALS['HTTP_HOST'].$GLOBALS['REQUEST_URI'])."</p>
			<h2>Session variables</h2>
			<ul>
			<li><a href='#post'>Post Variables</a></li>
			<li><a href='#get'>Get variables</a></li>
			<li><a href='#cookie'>Cookies</a></li>
			<li><a href='#global'>Globals</a></li>
			<li><a href='#backtrace'>Stack Trace</a></li>
			</ul>
			<h3 id='post'>Post variables</h3><a href='#top'>Top</a>
			<pre>".htmlspecialchars(print_r($_POST,true))."</pre>
			<h3 id='get'>Get variables</h3><a href='#top'>Top</a>
			<pre>".htmlspecialchars(print_r($_GET,true))."</pre>
			<h3 id='cookie'>Cookies</h3><a href='#top'>Top</a>
			<pre>".htmlspecialchars(print_r($_COOKIE,true))."</pre>
			<h3 id='global'>Globals</h3><a href='#top'>Top</a>
			<pre>".htmlspecialchars(print_r($GLOBALS,true))."</pre>
			<h3 id='backtrace'>Stack Trace</h3><a href='#top'>Top</a>
			<pre>".htmlspecialchars(print_r(debug_backtrace(),true))."</pre>
			<a href='#top'>Top</a>
			";
		
		$session = nuSession($_GET['ses']);
		
		if ($session->sss_access_level == 'globeadmin') {
		
			//Administrator response for debugging/development
			
			echo "<p><strong>The following information is only provided for users logged on as globeadmin.</strong></p>".$verboseOutput;
						
		} else {

			//Non-globeadmin response (send notification emails if any user except globeadmin is logged in)

			require_once("emaillib.php");
			
			$emailMessage = "An error has occurred on site '$db'<br />\nError Reference: $errorReference<br />";
			
			//Send email to client tech staff
			$errorClientMails = array_unique(explode(",",$ErrorEmailClientAddressList)); //Comma-separated list from config.php for this site
			
			// So the user doesn't have to wait for emails to send before seeing the error message.
			ob_flush();
			flush();
		
			foreach ($errorClientMails as $errorMail) {
				if (trim($errorMail) && trim($ErrorFromEmailAddress)) { //Ignore blank strings
					nuSendEmail(trim($errorMail), trim($ErrorFromEmailAddress), $message = "<html><body>$emailMessage</body></html>", $html = true, $subject = "Error Reference: $errorReference, Site: $db",$wordWrap = null, $filelist = null, $receipt = null);
				}
			}
			
			// Add detailed debugging data for site administrator
			$emailMessage .= $verboseOutput;
			
			//Send email to administrator(s)
			$errorAdminMails = array_unique(explode(",",$ErrorEmailAdminAddressList)); //Comma-separated list from config.php for this site
		
			foreach ($errorAdminMails as $errorMail) {
				if (trim($errorMail) && trim($ErrorFromEmailAddress)) { //Ignore blank strings
					nuSendEmail(trim($errorMail), trim($ErrorFromEmailAddress), $message = "<html><body>$emailMessage</body></html>", $html = true, $subject = "Error Reference: $errorReference, Site: $db",$wordWrap = null, $filelist = null, $receipt = null);
				}
			}
		}
	}

	die("</div></div></body></html>");
}

function db_fetch_object($resource){
	return mysql_fetch_object($resource);
}

function db_fetch_row($resource){
	return mysql_fetch_row($resource);
}

function db_fetch_array($resource){
	return mysql_fetch_array($resource);
}
function db_fetch_field($resource){
	return mysql_fetch_field($resource);
}

function db_insert_id($resource){
	return mysql_insert_id();
}

function db_num_rows($resource){
	return mysql_num_rows($resource);
}

function tableFieldNamesToArray($resource){
    $to               = mysql_num_fields($resource);
    $nameArray        = array();

    for($i = 0 ; $i < $to ; $i++){
        $nameArray[]  = mysql_field_name($resource,$i);
    }
    return $nameArray;
}


?>